/**
 * angular-fast-json-patch - Angular Fast Json Patch
 * @version v0.0.4
 * @author Jon Bone
 * @link https://github.com/bonejon/angular-fast-json-patch#readme
 * @license MIT
 */
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("@angular/core"));
	else if(typeof define === 'function' && define.amd)
		define(["@angular/core"], factory);
	else if(typeof exports === 'object')
		exports["ticktock"] = factory(require("@angular/core"));
	else
		root["ticktock"] = factory(root["ng"]["core"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_1__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 5);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(6));


/***/ }),
/* 1 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_1__;

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var operation_1 = __webpack_require__(3);
var json_patch_error_1 = __webpack_require__(8);
var operation_extensions_1 = __webpack_require__(9);
var deep_equals_1 = __webpack_require__(4);
var Helpers = /** @class */ (function () {
    function Helpers() {
    }
    /**
     * Deeply clone the object.
     * https://jsperf.com/deep-copy-vs-json-stringify-json-parse/25 (recursiveDeepCopy)
     * @param  {any} obj value to clone
     * @return {any} cloned obj
     */
    Helpers.deepClone = function (obj) {
        switch (typeof obj) {
            case 'object':
                // Faster than ES5 clone - http://jsperf.com/deep-cloning-of-objects/5
                return JSON.parse(JSON.stringify(obj));
            case 'undefined':
                // this is how JSON.stringify behaves for array items
                return null;
            default:
                // no need to clone primitives
                return obj;
        }
    };
    /**
     * Retrieves a value from a JSON document by a JSON pointer.
     * Returns the value.
     *
     * @param document The document to get the value from
     * @param pointer an escaped JSON pointer
     * @return The retrieved value
     */
    Helpers.getValueByPointer = function (document, pointer) {
        if (pointer === '') {
            return document;
        }
        var getOriginalDestination = new operation_1.Operation(operation_1.Operations.Get, pointer);
        this.applyOperation(document, getOriginalDestination);
        return getOriginalDestination.value;
    };
    /**
     * Apply a single JSON Patch Operation on a JSON document.
     * Returns the {newDocument, result} of the operation.
     * It modifies the `document` and `operation` objects - it gets the values by reference.
     * If you would like to avoid touching your values, clone them:
     * `jsonpatch.applyOperation(document, jsonpatch._deepClone(operation))`.
     *
     * @param document The document to patch
     * @param operation The operation to apply
     * @param validateOperation `false` is without validation, `true` to use default jsonpatch's validation, or you can pass a `validateOperation` callback to be used for validation.
     * @param mutateDocument Whether to mutate the original document or clone it before applying
     * @return `{newDocument, result}` after the operation
     */
    Helpers.applyOperation = function (document, operation, validateOperation, mutateDocument) {
        if (validateOperation === void 0) { validateOperation = false; }
        if (mutateDocument === void 0) { mutateDocument = true; }
        if (validateOperation) {
            if (typeof validateOperation === 'function') {
                validateOperation(operation, 0, document, operation.path);
            }
            else {
                Helpers.validator(operation, 0);
            }
        }
        /* ROOT OPERATIONS */
        if (operation.path === '') {
            var returnValue = { newDocument: document };
            if (operation.op === 'add') {
                returnValue.newDocument = operation.value;
                return returnValue;
            }
            else if (operation.op === 'replace') {
                returnValue.newDocument = operation.value;
                returnValue.removed = document; // document we removed
                return returnValue;
            }
            else if (operation.op === 'move' || operation.op === 'copy') {
                returnValue.newDocument = Helpers.getValueByPointer(document, operation.from); // get the value by json-pointer in `from` field
                if (operation.op === 'move') {
                    returnValue.removed = document;
                }
                return returnValue;
            }
            else if (operation.op === 'test') {
                returnValue.test = deep_equals_1.areEquals(document, operation.value);
                if (returnValue.test === false) {
                    throw new json_patch_error_1.JsonPatchError('Test operation failed', 'TEST_OPERATION_FAILED', 0, operation, document);
                }
                returnValue.newDocument = document;
                return returnValue;
            }
            else if (operation.op === 'remove') {
                returnValue.removed = document;
                returnValue.newDocument = null;
                return returnValue;
            }
            else if (operation.op === '_get') {
                operation.value = document;
                return returnValue;
            }
            else {
                if (validateOperation) {
                    throw new json_patch_error_1.JsonPatchError('Operation `op` property is not one of operations defined in RFC-6902', 'OPERATION_OP_INVALID', 0, operation, document);
                }
                else {
                    return returnValue;
                }
            }
            /* END ROOT OPERATIONS */
        }
        else {
            if (!mutateDocument) {
                document = Helpers.deepClone(document);
            }
            var path = operation.path || '';
            var keys = path.split('/');
            var obj = document;
            var t = 1; // skip empty element - http://jsperf.com/to-shift-or-not-to-shift
            var len = keys.length;
            var existingPathFragment = void 0;
            var key = void 0;
            var validateFunction = void 0;
            if (typeof validateOperation === 'function') {
                validateFunction = validateOperation;
            }
            else {
                validateFunction = Helpers.validator;
            }
            while (true) {
                key = keys[t];
                if (validateOperation) {
                    if (existingPathFragment) {
                        if (obj[key] === undefined) {
                            existingPathFragment = keys.slice(0, t).join('/');
                        }
                        else if (t === len - 1) {
                            existingPathFragment = operation.path;
                        }
                        if (existingPathFragment !== undefined) {
                            validateFunction(operation, 0, document, existingPathFragment);
                        }
                    }
                }
                t++;
                if (Array.isArray(obj)) {
                    if (key === '-') {
                        key = obj.length;
                    }
                    else {
                        if (validateOperation && !Helpers.isInteger(key)) {
                            throw new json_patch_error_1.JsonPatchError('Expected an unsigned base-10 integer value, making the new referenced value the array element with the zero-based index', 'OPERATION_PATH_ILLEGAL_ARRAY_INDEX', 0, operation.path, operation);
                        }
                        else if (Helpers.isInteger(key)) {
                            // only parse key when it's an integer for `arr.prop` to work
                            // tslint:disable-next-line:no-bitwise
                            key = ~~key;
                        }
                    }
                    if (t >= len) {
                        if (validateOperation && operation.op === 'add' && key > obj.length) {
                            throw new json_patch_error_1.JsonPatchError('The specified index MUST NOT be greater than the number of elements in the array', 'OPERATION_VALUE_OUT_OF_BOUNDS', 0, operation.path, operation);
                        }
                        var returnValue = operation_extensions_1.arrOps[operation.op].call(operation, obj, key, document); // Apply patch
                        if (returnValue.test === false) {
                            throw new json_patch_error_1.JsonPatchError('Test operation failed', 'TEST_OPERATION_FAILED', 0, operation, document);
                        }
                        return returnValue;
                    }
                }
                else {
                    if (key && key.indexOf('~') !== -1) {
                        key = Helpers.unescapePathComponent(key);
                    }
                    if (t >= len) {
                        var returnValue = operation_extensions_1.objOps[operation.op].call(operation, obj, key, document); // Apply patch
                        if (returnValue.test === false) {
                            throw new json_patch_error_1.JsonPatchError('Test operation failed', 'TEST_OPERATION_FAILED', 0, operation, document);
                        }
                        return returnValue;
                    }
                }
                obj = obj[key];
            }
        }
    };
    // 3x faster than cached /^\d+$/.test(str)
    Helpers.isInteger = function (str) {
        var i = 0;
        var len = str.length;
        var charCode;
        while (i < len) {
            charCode = str.charCodeAt(i);
            if (charCode >= 48 && charCode <= 57) {
                i++;
                continue;
            }
            return false;
        }
        return true;
    };
    Helpers.generate = function (mirror, obj, patches, path) {
        if (obj === mirror) {
            return;
        }
        if (typeof obj.toJSON === 'function') {
            obj = obj.toJSON();
        }
        var newKeys = this.objectKeys(obj);
        var oldKeys = this.objectKeys(mirror);
        var changed = false;
        var deleted = false;
        // if ever "move" operation is implemented here, make sure this test runs OK: "should not generate the same patch twice (move)"
        for (var okl = oldKeys.length - 1; okl >= 0; okl--) {
            var oldKey = oldKeys[okl];
            var oldVal = mirror[oldKey];
            if (Helpers.hasOwnProperty(obj, oldKey) && !(obj[oldKey] === undefined && oldVal !== undefined && Array.isArray(obj) === false)) {
                var newVal = obj[oldKey];
                if (typeof oldVal === 'object' && oldVal != null && typeof newVal === 'object' && newVal != null) {
                    Helpers.generate(oldVal, newVal, patches, path + '/' + Helpers.escapePathComponent(oldKey));
                }
                else {
                    if (oldVal !== newVal) {
                        changed = true;
                        patches.push({ op: 'replace', path: path + '/' + Helpers.escapePathComponent(oldKey), value: Helpers.deepClone(newVal) });
                    }
                }
            }
            else {
                patches.push({ op: 'remove', path: path + '/' + Helpers.escapePathComponent(oldKey) });
                deleted = true; // property has been deleted
            }
        }
        if (!deleted && newKeys.length === oldKeys.length) {
            return;
        }
        for (var _i = 0, newKeys_1 = newKeys; _i < newKeys_1.length; _i++) {
            var newKey = newKeys_1[_i];
            if (!Helpers.hasOwnProperty(mirror, newKey) && obj[newKey] !== undefined) {
                patches.push({ op: 'add', path: path + '/' + Helpers.escapePathComponent(newKey), value: Helpers.deepClone(obj[newKey]) });
            }
        }
    };
    /**
     * Apply a full JSON Patch array on a JSON document.
     * Returns the {newDocument, result} of the patch.
     * It modifies the `document` object and `patch` - it gets the values by reference.
     * If you would like to avoid touching your values, clone them:
     * `jsonpatch.applyPatch(document, jsonpatch._deepClone(patch))`.
     *
     * @param document The document to patch
     * @param patch The patch to apply
     * @param validateOperation `false` is without validation, `true` to use default jsonpatch's validation, or you can pass a `validateOperation` callback to be used for validation.
     * @param mutateDocument Whether to mutate the original document or clone it before applying
     * @return An array of `{newDocument, result}` after the patch
     */
    Helpers.applyPatch = function (document, patch, validateOperation, mutateDocument) {
        if (mutateDocument === void 0) { mutateDocument = true; }
        if (validateOperation) {
            if (!Array.isArray(patch)) {
                throw new json_patch_error_1.JsonPatchError('Patch sequence must be an array', 'SEQUENCE_NOT_AN_ARRAY');
            }
        }
        if (!mutateDocument) {
            document = Helpers.deepClone(document);
        }
        var results = new Array(patch.length);
        for (var i = 0, length_1 = patch.length; i < length_1; i++) {
            results[i] = Helpers.applyOperation(document, patch[i], validateOperation);
            document = results[i].newDocument; // in case root was replaced
        }
        results.newDocument = document;
        return results;
    };
    /**
     * Validates a single operation. Called from `jsonpatch.validate`. Throws `JsonPatchError` in case of an error.
     * @param {object} operation - operation object (patch)
     * @param {number} index - index of operation in the sequence
     * @param {object} [document] - object where the operation is supposed to be applied
     * @param {string} [existingPathFragment] - comes along with `document`
     */
    Helpers.validator = function (operation, index, document, existingPathFragment) {
        if (typeof operation !== 'object' || operation === null || Array.isArray(operation)) {
            throw new json_patch_error_1.JsonPatchError('Operation is not an object', 'OPERATION_NOT_AN_OBJECT', index, operation, document);
        }
        else if (!operation_extensions_1.objOps[operation.op]) {
            throw new json_patch_error_1.JsonPatchError('Operation `op` property is not one of operations defined in RFC-6902', 'OPERATION_OP_INVALID', index, operation, document);
        }
        else if (typeof operation.path !== 'string') {
            throw new json_patch_error_1.JsonPatchError('Operation `path` property is not a string', 'OPERATION_PATH_INVALID', index, operation, document);
        }
        else if (operation.path.indexOf('/') !== 0 && operation.path.length > 0) {
            // paths that aren't empty string should start with "/"
            throw new json_patch_error_1.JsonPatchError('Operation `path` property must start with "/"', 'OPERATION_PATH_INVALID', index, operation, document);
        }
        else if ((operation.op === 'move' || operation.op === 'copy') && typeof operation.from !== 'string') {
            throw new json_patch_error_1.JsonPatchError('Operation `from` property is not present (applicable in `move` and `copy` operations)', 'OPERATION_FROM_REQUIRED', index, operation, document);
        }
        else if ((operation.op === 'add' || operation.op === 'replace' || operation.op === 'test') && operation.value === undefined) {
            throw new json_patch_error_1.JsonPatchError('Operation `value` property is not present (applicable in `add`, `replace` and `test` operations)', 'OPERATION_VALUE_REQUIRED', index, operation, document);
        }
        else if ((operation.op === 'add' || operation.op === 'replace' || operation.op === 'test') && this.hasUndefined(operation.value)) {
            throw new json_patch_error_1.JsonPatchError('Operation `value` property is not present (applicable in `add`, `replace` and `test` operations)', 'OPERATION_VALUE_CANNOT_CONTAIN_UNDEFINED', index, operation, document);
        }
        else if (document) {
            if (operation.op === 'add') {
                var pathLen = operation.path.split('/').length;
                var existingPathLen = existingPathFragment.split('/').length;
                if (pathLen !== existingPathLen + 1 && pathLen !== existingPathLen) {
                    throw new json_patch_error_1.JsonPatchError('Cannot perform an `add` operation at the desired path', 'OPERATION_PATH_CANNOT_ADD', index, operation, document);
                }
            }
            else if (operation.op === 'replace' || operation.op === 'remove' || operation.op === '_get') {
                if (operation.path !== existingPathFragment) {
                    throw new json_patch_error_1.JsonPatchError('Cannot perform the operation at a path that does not exist', 'OPERATION_PATH_UNRESOLVABLE', index, operation, document);
                }
            }
            else if (operation.op === 'move' || operation.op === 'copy') {
                var existingValue = new operation_1.Operation(operation_1.Operations.Get, operation.from, undefined);
                var error = Helpers.validate([existingValue], document);
                if (error && error.name === 'OPERATION_PATH_UNRESOLVABLE') {
                    throw new json_patch_error_1.JsonPatchError('Cannot perform the operation from a path that does not exist', 'OPERATION_FROM_UNRESOLVABLE', index, operation, document);
                }
            }
        }
    };
    /**
     * Validates a sequence of operations. If `document` parameter is provided, the sequence is additionally validated against the object document.
     * If error is encountered, returns a JsonPatchError object
     * @param sequence
     * @param document
     * @returns {JsonPatchError|undefined}
     */
    Helpers.validate = function (sequence, document, externalValidator) {
        try {
            if (!Array.isArray(sequence)) {
                throw new json_patch_error_1.JsonPatchError('Patch sequence must be an array', 'SEQUENCE_NOT_AN_ARRAY');
            }
            if (document) {
                // clone document and sequence so that we can safely try applying operations
                Helpers.applyPatch(Helpers.deepClone(document), Helpers.deepClone(sequence), externalValidator || true);
            }
            else {
                var validatorFunction = externalValidator.validate || Helpers.validator;
                for (var i = 0; i < sequence.length; i++) {
                    validatorFunction(sequence[i], i, document, undefined);
                }
            }
        }
        catch (e) {
            if (e instanceof json_patch_error_1.JsonPatchError) {
                return e;
            }
            else {
                throw e;
            }
        }
    };
    /**
     * Recursively checks whether an object has any undefined values inside.
     */
    Helpers.hasUndefined = function (obj) {
        if (obj === undefined) {
            return true;
        }
        if (obj) {
            if (Array.isArray(obj)) {
                for (var a = 0, len = obj.length; a < len; a++) {
                    if (this.hasUndefined(obj[a])) {
                        return true;
                    }
                }
            }
            else if (typeof obj === 'object') {
                var objKeys = Helpers.objectKeys(obj);
                var objKeysLength = objKeys.length;
                for (var i = 0; i < objKeysLength; i++) {
                    if (Helpers.hasUndefined(obj[objKeys[i]])) {
                        return true;
                    }
                }
            }
        }
        return false;
    };
    Helpers.hasOwnProperty = function (obj, key) {
        return Helpers._hasOwnProperty.call(obj, key);
    };
    Helpers.objectKeys = function (obj) {
        if (Array.isArray(obj)) {
            var arrayKeys = new Array(obj.length);
            for (var k = 0; k < arrayKeys.length; k++) {
                arrayKeys[k] = '' + k;
            }
            return arrayKeys;
        }
        if (Object.keys) {
            return Object.keys(obj);
        }
        var keys = [];
        for (var i in obj) {
            if (Helpers.hasOwnProperty(obj, i)) {
                keys.push(i);
            }
        }
        return keys;
    };
    /**
     * Unescapes a json pointer path
     * @param path The escaped pointer
     * @return The unescaped path
     */
    Helpers.unescapePathComponent = function (path) {
        var newPath = path.replace(/~1/g, '/');
        newPath = newPath.replace(/~0/g, '~');
        return newPath;
    };
    /**
     * Escapes a json pointer path
     * @param path The raw pointer
     * @return the Escaped path
     */
    Helpers.escapePathComponent = function (path) {
        if (path.indexOf('/') === -1 && path.indexOf('~') === -1) {
            return path;
        }
        return path.replace(/~/g, '~0').replace(/\//g, '~1');
    };
    Helpers._hasOwnProperty = Object.prototype.hasOwnProperty;
    return Helpers;
}());
exports.Helpers = Helpers;


/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var Operation = /** @class */ (function () {
    function Operation(operation, path, value, from) {
        this._operation = operation;
        this.path = path;
        this.value = value;
        this.from = from;
    }
    Object.defineProperty(Operation.prototype, "op", {
        get: function () {
            switch (this._operation) {
                case Operations.Add:
                    return 'add';
                case Operations.Remove:
                    return 'remove';
                case Operations.Replace:
                    return 'replace';
                case Operations.Move:
                    return 'move';
                case Operations.Copy:
                    return 'copy';
                case Operations.Test:
                    return 'test';
                case Operations.Get:
                    return '_get';
                default:
                    throw new Error('Invalid Operation');
            }
        },
        enumerable: true,
        configurable: true
    });
    return Operation;
}());
exports.Operation = Operation;
var Operations;
(function (Operations) {
    Operations[Operations["Add"] = 1] = "Add";
    Operations[Operations["Remove"] = 2] = "Remove";
    Operations[Operations["Replace"] = 3] = "Replace";
    Operations[Operations["Move"] = 4] = "Move";
    Operations[Operations["Copy"] = 5] = "Copy";
    Operations[Operations["Test"] = 6] = "Test";
    Operations[Operations["Get"] = 7] = "Get";
})(Operations = exports.Operations || (exports.Operations = {}));


/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
function areEquals(a, b) {
    if (a === b) {
        return true;
    }
    var arrA = Array.isArray(a);
    var arrB = Array.isArray(b);
    var i;
    if (arrA && arrB) {
        if (a.length !== b.length) {
            return false;
        }
        for (i = 0; i < a.length; i++) {
            if (!Object.is(a[i], b[i])) {
                return false;
            }
        }
        return true;
    }
    if (arrA !== arrB) {
        return false;
    }
    if (a && b && typeof a === 'object' && typeof b === 'object') {
        var keys = Object.keys(a);
        if (keys.length !== Object.keys(b).length) {
            return false;
        }
        var dateA = a instanceof Date;
        var dateB = b instanceof Date;
        if (dateA && dateB) {
            return a.getTime() === b.getTime();
        }
        if (dateA !== dateB) {
            return false;
        }
        var regexpA = a instanceof RegExp;
        var regexpB = b instanceof RegExp;
        if (regexpA && regexpB) {
            return a.toString() === b.toString();
        }
        if (regexpA !== regexpB) {
            return false;
        }
        for (i = 0; i < keys.length; i++) {
            if (!Object.prototype.hasOwnProperty.call(b, keys[i])) {
                return false;
            }
        }
        for (i = 0; i < keys.length; i++) {
            if (!Object.is(a[keys[i]], b[keys[i]])) {
                return false;
            }
        }
        return true;
    }
    return false;
}
exports.areEquals = areEquals;


/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var services_1 = __webpack_require__(0);
exports.FastJsonPatchService = services_1.FastJsonPatchService;
var angular_fast_json_patch_module_1 = __webpack_require__(13);
exports.FastJsonPatchModule = angular_fast_json_patch_module_1.FastJsonPatchModule;


/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(7));


/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = __webpack_require__(1);
var helpers_1 = __webpack_require__(2);
var observer_1 = __webpack_require__(10);
var mirror_1 = __webpack_require__(11);
var observerinfo_1 = __webpack_require__(12);
/**
 * FastJsonPatchService class.
 */
var FastJsonPatchService = /** @class */ (function () {
    function FastJsonPatchService() {
        this.beforeObjects = [];
    }
    /**
     * Generate an array of patches from an observer
     */
    FastJsonPatchService.prototype.generate = function (observer) {
        var mirror = this.getMirror(observer.object);
        if (mirror) {
            helpers_1.Helpers.generate(mirror.originalObject, observer.object, observer.patches, '');
            if (observer.patches.length) {
                helpers_1.Helpers.applyPatch(mirror.originalObject, observer.patches);
            }
            var temp = observer.patches;
            if (temp.length > 0) {
                observer.patches = [];
                if (observer.callback) {
                    observer.callback(temp);
                }
            }
            return temp;
        }
        else {
            throw new Error('Mirror not found');
        }
    };
    FastJsonPatchService.prototype.observe = function (obj, callback) {
        var _this = this;
        var observer;
        var root = obj;
        var mirror = this.getMirror(obj);
        if (!mirror) {
            mirror = new mirror_1.Mirror(obj);
            this.beforeObjects.push(mirror);
        }
        else {
            observer = this.getObserverFromMirror(mirror, callback);
        }
        if (observer) {
            return observer;
        }
        observer = new observer_1.Observer();
        mirror.originalObject = helpers_1.Helpers.deepClone(obj);
        mirror.obj = obj;
        var dirtyCheck = function () {
            _this.generate(observer);
        };
        var fastCheck = function () {
            clearTimeout(observer.nextHandle);
            observer.nextHandle = setTimeout(dirtyCheck);
        };
        if (callback) {
            observer.callback = callback;
            observer.nextHandle = null;
            if (typeof window !== 'undefined') {
                if (window.addEventListener) {
                    window.addEventListener('mouseup', fastCheck);
                    window.addEventListener('keyup', fastCheck);
                    window.addEventListener('mousedown', fastCheck);
                    window.addEventListener('keydown', fastCheck);
                    window.addEventListener('change', fastCheck);
                }
                else {
                    var documentElement = document.documentElement;
                    documentElement.attachEvent('onmouseup', fastCheck);
                    documentElement.attachEvent('onkeyup', fastCheck);
                    documentElement.attachEvent('onmousedown', fastCheck);
                    documentElement.attachEvent('onkeydown', fastCheck);
                    documentElement.attachEvent('onchange', fastCheck);
                }
            }
        }
        observer.patches = [];
        observer.object = obj;
        observer.unobserve = function () {
            var unobserveMirror = _this.getMirror(observer.object);
            _this.generate(observer);
            clearTimeout(observer.nextHandle);
            _this.removeObserverFromMirror(unobserveMirror, observer);
            if (unobserveMirror.observers.length === 0) {
                // there are no observables anymore so discard the mirror
                var mirrorIndex = _this.beforeObjects.indexOf(unobserveMirror);
                _this.beforeObjects.splice(mirrorIndex, 1);
                unobserveMirror = undefined;
            }
            if (typeof window !== 'undefined') {
                if (window.removeEventListener) {
                    window.removeEventListener('mouseup', fastCheck);
                    window.removeEventListener('keyup', fastCheck);
                    window.removeEventListener('mousedown', fastCheck);
                    window.removeEventListener('keydown', fastCheck);
                }
                else {
                    var documentElement = document.documentElement;
                    documentElement.detachEvent('onmouseup', fastCheck);
                    documentElement.detachEvent('onkeyup', fastCheck);
                    documentElement.detachEvent('onmousedown', fastCheck);
                    documentElement.detachEvent('onkeydown', fastCheck);
                }
            }
        };
        mirror.observers.push(new observerinfo_1.ObserverInfo(callback, observer));
        return observer;
    };
    FastJsonPatchService.prototype.compare = function (source, target) {
        var patches = [];
        helpers_1.Helpers.generate(source, target, patches, '');
        return patches;
    };
    FastJsonPatchService.prototype.unobserve = function (observer) {
        observer.unobserve();
    };
    FastJsonPatchService.prototype.getMirror = function (obj) {
        for (var i = 0, length_1 = this.beforeObjects.length; i < length_1; i++) {
            if (this.beforeObjects[i].obj === obj) {
                return this.beforeObjects[i];
            }
        }
    };
    FastJsonPatchService.prototype.getObserverFromMirror = function (mirror, callback) {
        for (var j = 0, length_2 = mirror.observers.length; j < length_2; j++) {
            if (mirror.observers[j].callback === callback) {
                return mirror.observers[j].observer;
            }
        }
    };
    FastJsonPatchService.prototype.removeObserverFromMirror = function (mirror, observer) {
        var observerIndex = mirror.observers.indexOf(observer);
        mirror.observers.splice(observerIndex, 1);
    };
    FastJsonPatchService = __decorate([
        core_1.Injectable()
    ], FastJsonPatchService);
    return FastJsonPatchService;
}());
exports.FastJsonPatchService = FastJsonPatchService;


/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var JsonPatchError = /** @class */ (function (_super) {
    __extends(JsonPatchError, _super);
    function JsonPatchError(message, name, index, operation, tree) {
        var _this = _super.call(this, message) || this;
        _this.message = message;
        _this.name = name;
        _this.index = index;
        _this.operation = operation;
        _this.tree = tree;
        return _this;
    }
    return JsonPatchError;
}(Error));
exports.JsonPatchError = JsonPatchError;


/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var helpers_1 = __webpack_require__(2);
var operation_1 = __webpack_require__(3);
var deep_equals_1 = __webpack_require__(4);
/* We use a Javascript hash to store each
 function. Each hash entry (property) uses
 the operation identifiers specified in rfc6902.
 In this way, we can map each patch operation
 to its dedicated function in efficient way.
 */
/* The operations applicable to an object */
exports.objOps = {
    this: this,
    add: function (obj, key, document) {
        obj[key] = exports.objOps.this.value;
        return { newDocument: document };
    },
    remove: function (obj, key, document) {
        var removed = obj[key];
        delete obj[key];
        return { newDocument: document, removed: removed };
    },
    replace: function (obj, key, document) {
        var removed = obj[key];
        obj[key] = exports.objOps.this.value;
        return { newDocument: document, removed: removed };
    },
    move: function (obj, key, document) {
        /* in case move target overwrites an existing value,
        return the removed value, this can be taxing performance-wise,
        and is potentially unneeded */
        var removed = helpers_1.Helpers.getValueByPointer(document, exports.objOps.this.path);
        if (removed) {
            removed = helpers_1.Helpers.deepClone(removed);
        }
        var removeOperation = new operation_1.Operation(operation_1.Operations.Remove, exports.objOps.this.from);
        var originalValue = helpers_1.Helpers.applyOperation(document, removeOperation).removed;
        var addOperation = new operation_1.Operation(operation_1.Operations.Add, exports.objOps.this.path, originalValue);
        helpers_1.Helpers.applyOperation(document, addOperation);
        return { newDocument: document, removed: removed };
    },
    copy: function (obj, key, document) {
        var valueToCopy = helpers_1.Helpers.getValueByPointer(document, exports.objOps.this.from);
        // enforce copy by value so further operations don't affect source (see issue #177)
        var addOperation = new operation_1.Operation(operation_1.Operations.Add, exports.objOps.this.path, helpers_1.Helpers.deepClone(valueToCopy));
        helpers_1.Helpers.applyOperation(document, addOperation);
        return { newDocument: document };
    },
    test: function (obj, key, document) {
        return { newDocument: document, test: deep_equals_1.areEquals(obj[key], exports.objOps.this.value) };
    },
    _get: function (obj, key, document) {
        exports.objOps.this.value = obj[key];
        return { newDocument: document };
    }
};
/* The operations applicable to an array. Many are the same as for the object */
exports.arrOps = {
    this: this,
    add: function (arr, i, document) {
        if (helpers_1.Helpers.isInteger(i)) {
            arr.splice(i, 0, exports.arrOps.this.value);
        }
        else {
            arr[i] = exports.arrOps.this.value;
        }
        // this may be needed when using '-' in an array
        return { newDocument: document, index: i };
    },
    remove: function (arr, i, document) {
        var removedList = arr.splice(i, 1);
        return { newDocument: document, removed: removedList[0] };
    },
    replace: function (arr, i, document) {
        var removed = arr[i];
        arr[i] = exports.arrOps.this.value;
        return { newDocument: document, removed: removed };
    },
    move: exports.objOps.move,
    copy: exports.objOps.copy,
    test: exports.objOps.test,
    _get: exports.objOps._get
};


/***/ }),
/* 10 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var Observer = /** @class */ (function () {
    function Observer() {
    }
    return Observer;
}());
exports.Observer = Observer;


/***/ }),
/* 11 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var Mirror = /** @class */ (function () {
    function Mirror(obj) {
        this.observers = new Array();
        this.obj = obj;
    }
    return Mirror;
}());
exports.Mirror = Mirror;


/***/ }),
/* 12 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var ObserverInfo = /** @class */ (function () {
    function ObserverInfo(callback, observer) {
        this._callback = callback;
        this._observer = observer;
    }
    Object.defineProperty(ObserverInfo.prototype, "callback", {
        get: function () {
            return this._callback;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ObserverInfo.prototype, "observer", {
        get: function () {
            return this._observer;
        },
        enumerable: true,
        configurable: true
    });
    return ObserverInfo;
}());
exports.ObserverInfo = ObserverInfo;


/***/ }),
/* 13 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = __webpack_require__(1);
var services_1 = __webpack_require__(0);
var FastJsonPatchModule = /** @class */ (function () {
    function FastJsonPatchModule() {
    }
    FastJsonPatchModule = __decorate([
        core_1.NgModule({
            providers: [
                services_1.FastJsonPatchService,
            ]
        })
    ], FastJsonPatchModule);
    return FastJsonPatchModule;
}());
exports.FastJsonPatchModule = FastJsonPatchModule;


/***/ })
/******/ ]);
});
//# sourceMappingURL=index.umd.js.map