import { Operation } from './operation';
import { Observer } from './observer';
import { Mirror } from './mirror';
/**
 * FastJsonPatchService class.
 */
export declare class FastJsonPatchService {
    beforeObjects: Mirror[];
    /**
     * Generate an array of patches from an observer
     */
    generate<T>(observer: Observer<T>): Operation[];
    observe<T>(obj: any, callback?: (patches: Operation[]) => void): Observer<T>;
    compare<T>(source: T, target: T): Operation[];
    unobserve<T>(observer: Observer<T>): void;
    private getMirror(obj);
    private getObserverFromMirror(mirror, callback);
    private removeObserverFromMirror(mirror, observer);
}
