export function areEquals(a, b) {
    if (a === b) {
        return true;
    }
    var arrA = Array.isArray(a);
    var arrB = Array.isArray(b);
    var i;
    if (arrA && arrB) {
        if (a.length !== b.length) {
            return false;
        }
        for (i = 0; i < a.length; i++) {
            if (!Object.is(a[i], b[i])) {
                return false;
            }
        }
        return true;
    }
    if (arrA !== arrB) {
        return false;
    }
    if (a && b && typeof a === 'object' && typeof b === 'object') {
        var keys = Object.keys(a);
        if (keys.length !== Object.keys(b).length) {
            return false;
        }
        var dateA = a instanceof Date;
        var dateB = b instanceof Date;
        if (dateA && dateB) {
            return a.getTime() === b.getTime();
        }
        if (dateA !== dateB) {
            return false;
        }
        var regexpA = a instanceof RegExp;
        var regexpB = b instanceof RegExp;
        if (regexpA && regexpB) {
            return a.toString() === b.toString();
        }
        if (regexpA !== regexpB) {
            return false;
        }
        for (i = 0; i < keys.length; i++) {
            if (!Object.prototype.hasOwnProperty.call(b, keys[i])) {
                return false;
            }
        }
        for (i = 0; i < keys.length; i++) {
            if (!Object.is(a[keys[i]], b[keys[i]])) {
                return false;
            }
        }
        return true;
    }
    return false;
}
//# sourceMappingURL=deep-equals.js.map