var Operation = /** @class */ (function () {
    function Operation(operation, path, value, from) {
        this._operation = operation;
        this.path = path;
        this.value = value;
        this.from = from;
    }
    Object.defineProperty(Operation.prototype, "op", {
        get: function () {
            switch (this._operation) {
                case Operations.Add:
                    return 'add';
                case Operations.Remove:
                    return 'remove';
                case Operations.Replace:
                    return 'replace';
                case Operations.Move:
                    return 'move';
                case Operations.Copy:
                    return 'copy';
                case Operations.Test:
                    return 'test';
                case Operations.Get:
                    return '_get';
                default:
                    throw new Error('Invalid Operation');
            }
        },
        enumerable: true,
        configurable: true
    });
    return Operation;
}());
export { Operation };
export var Operations;
(function (Operations) {
    Operations[Operations["Add"] = 1] = "Add";
    Operations[Operations["Remove"] = 2] = "Remove";
    Operations[Operations["Replace"] = 3] = "Replace";
    Operations[Operations["Move"] = 4] = "Move";
    Operations[Operations["Copy"] = 5] = "Copy";
    Operations[Operations["Test"] = 6] = "Test";
    Operations[Operations["Get"] = 7] = "Get";
})(Operations || (Operations = {}));
//# sourceMappingURL=operation.js.map